#!/bin/bash


function user() {
	rm /dev/shm/ezgo
	UID_MIN=`cat /etc/login.defs | egrep "^UID_MIN" | gawk ' { print $2; } '`
	UID_MAX=`cat /etc/login.defs | egrep "^UID_MAX" | gawk ' { print $2; } '`

	while read myLine
	do
		TMP1=${myLine/:/ }
		TMP2=${TMP1/:/ }
		TMP3=${TMP2/:/ }
		TMP4=${TMP3/:/ }
		USERNAME=`echo $TMP4 | gawk ' { print $1; }'`
		USERUID=`echo $TMP4 | gawk ' { print $3; } '`
		if [ $USERUID -ge `expr $UID_MIN - 1` ]; then
			if [ $USERUID -le $UID_MAX ]; then
				echo $USERNAME >>/dev/shm/ezgo
			fi
		fi
	done < /etc/passwd	
	username=$(cat /dev/shm/ezgo |tr '\n' ' ')
}
#zh_TW lang=([0]"系統開機還原設定" [1]"選項" [2]"請選擇您要的項目" [3]"設定開機時系統自動還原" [4]"解除開機自動還原設定" [5]"設定開機時系統自動還原" [6]"請選擇要開機還原的帳號" [7]"請選擇您要的帳號" [8]"系統備份中請稍待..." [9]"系統開機還原設定完成" [10]"解除開機自動還原設定" [11]"請選擇要開機還原的帳號" [12]"請選擇您要的帳號" [13]"解除開機自動還原設定完成" [14]"備份資料夾..."

function zh_TW {
lang=("系統開機還原設定" "選項" "請選擇您要的項目" "設定開機時系統自動還原" "解除開機自動還原設定" "設定開機時系統自動還原" "請選擇要開機還原的帳號" "請選擇您要的帳號" "系統備份中請稍待..." "系統開機還原設定完成" "解除開機自動還原設定" "請選擇要開機還原的帳號" "請選擇您要的帳號" "解除開機自動還原設定完成" "備份資料夾...")
}


function en_US {
lang=("System restore settings" "Options" "Please choose an option" "Restore default system settings at boot time" "Do not restore default system settings at boot time" "thenSystem restore setting stored." "Please choose which account to restore the default settings" "Please choose an account" "Running system backup.  Please wait..." "System restore setting stored. " "Do not restore default system settings at boot time" "Please choose which account to restore the default settings" "Please choose an account" "System restore setting stored." "Copy backup user dir.")
}

locale=$(env |grep "LANG="|sed  s/LANG=//g|sed s/.UTF-8//g|sed s/.utf8//g)
$locale;
if [ -e /etc/user_recover ]; then
        echo "已經有user_recover資料夾"
  else
       mkdir /etc/user_recover
  fi


input=$(zenity --list --radiolist --text "${lang[0]}" --column="${lang[1]}" --column="${lang[2]}" 1 "${lang[3]}" 2 "${lang[4]}")

if [ "$input" == "${lang[3]}" ]; then
	user;
        tar=$(zenity --list --text "${lang[6]}" --column="${lang[7]}" $username)		
       	
	case $tar in
	         "")
		exit 0
	    ;;
	    *)
                rm -rf /home/$tar/.kde/socket-*
                rm -rf /home/$tar/.kde/tmp-*
                rm -rf /home/$tar/.kde/cache-*
		rm -rf /home/$tar/.cache/*
		rm -rf /home/$tar/.Xauthority.*
		rm -rf /home/$tar/.xsession-errors.*
		rm -rf /home/$tar/.macromedia/*
		cp -a /home/$tar /etc/user_recover/$tar | tee >(zenity --progress --pulsate --text="${lang[14]}"  --auto-close)
		#tar jcvpf /etc/user_recover/$tar.tar /etc/user_recover/$tar | tee >(zenity --progress --pulsate --text="${lang[8]}"  --auto-close)

		ls /home/$tar |tr '\n' ' ' >/etc/user_recover/$tar.txt           
		echo '#!/bin/sh' >/etc/init.d/restore_"$tar".sh
		echo '/usr/bin/rsync -a --delete /etc/user_recover/'"$tar"' /home/' >> /etc/init.d/restore_"$tar".sh
		#echo 'rm -rf /home/'"$tar"'/' >>/etc/init.d/restore_"$tar".sh
		##echo 'mv /etc/user_recover/'"$tar"' /home' >>/etc/init.d/restore_"$tar".sh
		#echo '#!/bin/sh' >/etc/init.d/restore_"$tar"_tar.sh
		#echo 'sleep 10' >>/etc/init.d/restore_"$tar"_tar.sh
		#echo 'tar jxvpf /etc/user_recover/'"$tar"'.tar -C /' >>/etc/init.d/restore_"$tar"_tar.sh
		chmod +x /etc/init.d/restore_"$tar".sh
		#chmod +x /etc/init.d/restore_"$tar"_tar.sh
		cd /etc/init.d
		#update-rc.d restore_"$tar".sh start 10 S .
		#update-rc.d restore_"$tar".sh start 20 2 3 4 5 .
		update-rc.d restore_"$tar".sh start 20 0 6 . 
		zenity --info --text "${lang[9]}"

	    ;;
	esac

else 
	if [ "$input" == "${lang[4]}" ]; then
	ls /etc/user_recover/*.txt |sed -e 's/.txt/ /g' |sed -e 's/[/]etc[/]user_recover[/]//g' >/dev/shm/unezgo	
	username=$(cat /dev/shm/unezgo |tr '\n' ' ')
    	tar=$(zenity --list --text "${lang[10]}" --column="${lang[12]}" $username)		
		
	case $tar in
	         "")
		exit 0
	    ;;
	    *)
		sudo rm -rf /etc/user_recover/$tar.tar
		sudo rm -rf /etc/user_recover/$tar.txt	
		sudo rm -rf /etc/user_recover/$tar	
		sudo update-rc.d -f restore_"$tar".sh remove
		#sudo update-rc.d -f restore_"$tar"_tar.sh remove
		sudo rm -rf /etc/init.d/restore_"$tar"*
               	zenity --info --text "${lang[13]}"
		
	    ;;
	esac
	
	else 
		exit 0

	fi

fi


